 /*==============================================================================
*
*       filename        CAMERADLL.h
*       purpose         ṩк궨壬õĶ̬ĺ壬ṹһЩȫֱ
                        塣
*       language        Microsoft Visual C 6.0
*       author          zhang lei
*       date            04-10
*-----------------------
*       modify by       zhan lei
*       purpose         remark
*       language        Microsoft Visual C 6.0 
*       date            04-11-16
*
*-----------------------
*       modify by       yao yuhua
*       purpose         remark
*       language        Microsoft Visual C 6.0 
*       date            05-10-16
*
*-----------------------
*       modify by       Song wei
*       purpose         remark
*       language        Microsoft Visual C 6.0 
*       date            07-6-27
*-----------------------
*       modify by       Song wei
*       purpose         á쳣ʽڲ⣬ԭmessagebox
*       language        Microsoft Visual C 6.0 
*       date            07-01-26
*-----------------------
*		Copyright (C).  All Rights Reserved.
*
*
*==============================================================================*/

#ifndef CAMERADLL_H
#define CAMERADLL_H

DECLARE_HANDLE(HDIB);

//òṹ
struct Config_Value
{
	long size;                      //struct size, must be set
	long ident_code;             	//struct identity codeto mark the struct validity
	long type_code;                 //product type code
	long ver_code;              	//hardware type code
    long constant_swinterval;       //part begin interval
    long constant_totallength;      //total line

	long ccd_gain;					//ccd gain range:0~1023
	long ref_black;					//black level 0~255
	long work_mode;					//work mode
	long gamma_mode;				//gamma correction mode

	long frame_mode;				//frame mode
	long test_mode;					//test mode
	long part_begin;                //line of part beginvalidates in part mode
	long part_end;					//line of part end, validates in part mode

	long expose_line;				//expose line
	long r_gain;					//r gain, for color camera
	long g_gain;					//g gain, for color camera
	long b_gain;					//b gain, for color camera

    long color_saturation;			//color saturation, for color camera 
	long frame_rate;				//frame rate index	
	long b_level;					//reserved 
	long clock_value;               //clock value

	long cirl_radius;               //circular blanking radius
	long cirl_corehs;               //circular blanking core horizontal coordinate
	long cirl_corevs;			    //circular blanking core vertical coordinate 

	long Expose_time;//USB Camera expose time
	long Red_Brightness;//USB Camera red brightness
	long Green_Brightness;//USB Camera green brightness
	long Blue_Brightness;//USB Camera blue brightness

	long Gain;//USB Camera CCD gain
	long TrigStatus;
	
	long recursion_param;//recurison param
    long videomode;//
	long inverse_hor;//horizantal inverse
	long inverse_ver;//vertical inverse
    long frame_rate_value;//value of framerate
	long reserved[6];//reservedmust be 0
};
//ӹܲṹ
struct Config_Value_Ex
{
	long trigdelay_redge;
	long trigdelay_dedge;
	long trigend_shild;
	long trig_longexpose;

	long reserved[28];
};
//USB info structure 
/*
typedef struct _usbinfo//DLLеĶ屣һ
{
	DWORD	dwSize;				//ṹС
	DWORD	dwType;				//豸
	char	szDeviceName[32];	//豸
	DWORD	dwEzVer;			//68013 soft version
	DWORD	dwFpgaVer;			//fpga version
	DWORD	dwFpgaType;			//fpga type
	DWORD	dwMaxExpolLines;	//ع
	DWORD	dwMinExpolLines;	//Сع
	DWORD	dwMaxWidth;			//ɲɼ
	DWORD	dwMaxHeight;		//ɲɼ
	DWORD	dwConvertType;		//ݸʽ
	long	lReverse;			//Ƿת
	DWORD	dwReverse[28];		// must 0
}USBINFO, *LPUSBINFO;
*/
typedef struct _usbinfo
{
	DWORD	dwSize;				//ṹС
	DWORD	dwType;				//豸
	char	szDeviceName[32];	//豸
	DWORD	dwEzVer;			//68013 soft version
	DWORD	dwFpgaVer;			//fpga version
	DWORD	dwFpgaType;			//fpga type
	DWORD	dwMaxExpolLines;	//ع
	DWORD	dwMinExpolLines;	//Сع
	DWORD	dwMaxWidth;			//ɲɼ
	DWORD	dwMaxHeight;		//ɲɼ
	DWORD	dwConvertType;		//ݸʽ
	long	lReverse;			//Ƿת
	DWORD	dwReverse[28];		// must 0
}USBINFO, *LPUSBINFO;
//ǧ
typedef struct 
{
	long size;
	long ProductID;//typecode*
	long ProductDate;
	long SaleID;
	long SaleDate;
	long Ver;//*
	long dwIPAddress;//remote ip 16byte*
	long dwNetIPAddr;//local ip 16byte
	long dwMacAdress;//mac 12byte
	long hCom;
	long reserved5;
	long reserved6;
	long reserved7;
}CAMERAINFO,*LPCAMERAINFO;

//parameter definition for okCamSetConfigParam and okCamGetConfigParam
#define CONFIG_ALLPARAM -1              //set all parameters
#define CONFIG_INIPARAM -2              //set all parameters to default
#define CONFIG_CCDGAIN 1				//CCD gain
#define CONFIG_WORKMODE 2				//work mode 
#define CONFIG_GAMMAMODE 3				//gamma mode
#define CONFIG_REFBLACK 4				//black level
#define CONFIG_FRAMEMODE 5				//frame mode
#define CONFIG_TESTMODE 6				//test mode
#define CONFIG_PARTBEGIN 7				//line of part begin 
#define CONFIG_PARTEND 8				//line of part end
#define CONFIG_EXPOSE 9					//expose line
#define CONFIG_RGAIN 10					//R gain
#define CONFIG_GGAIN  11				//G gain 
#define CONFIG_BGAIN  12				//B gain 
#define CONFIG_COLORSATURATION 13		//color saturation
#define CONFIG_FRAMERATE 14				//frame rate index
#define CONFIG_GAMMA	15				//gamma parameter
#define CONFIG_CIRLRADIUS 16            //circular blanking radius
#define CONFIG_CIRLCOREHS 17            //circular blanking core horizontal coordinate
#define CONFIG_CIRLCOREVS 18            //circular blanking core vertical coordinate
#define CONFIG_EXPOSETIME 19            //expose time for USB camera
#define CONFIG_BRIGHTNESS 4            //brightness for USB camera
#define CONFIG_REDBRIGHTNESS 21         //red brightness for USB camera    
#define CONFIG_GREENBRIGHTNESS 22       //green brightness for USB camera
#define CONFIG_BLUEBRIGHTNESS 23        //blue brightness for USB camera
#define CONFIG_ALLCONTRAST 24          //second level CCD gain for AC1310 
#define CONFIG_CONTRAST 1              //contrast for USB camera      
#define CONFIG_REDCONTRAST 10           //red contrast for USB camera
#define CONFIG_GREENCONTRAST 11         //green contrast for USB camera
#define CONFIG_BLUECONTRAST 12          //blue contrast for USB camera
#define CONFIG_RECURSION   25//ݹ
#define CONFIG_VIDEOMODE   26//1 Ч0 Ч
#define CONFIG_INVERSE_HOR 27//ˮƽתң1 Ч0Ч
#define CONFIG_INVERSE_VER 28//ֱת£1 Ч0Ч
#define CONFIG_SHORT_EXPOSE 29 //عʱ䣬ЧΧ:0~255,붩AM1430I
//֡Ƶֵ
#define CONFIG_FRAMERATE_EX 30  
//չ
#define CONFIG_TRIG_DELAY_REDGE 31//ⴥ˲ʱ
#define CONFIG_TRIG_DELAY_DEDGE 32//ⴥ½˲ʱ
#define CONFIG_TRIG_END_SHILD   33//ⴥ
#define CONFIG_ALLPARAM_EX 34             //չȫ
#define CONFIG_INITPARAM_EX 35             //չȫΪȱʡֵ
#define CONFIG_TRIG_LONGEXPOSE  36             //ⴥع

//USB INFO for okCamGetUsbInfo
#define DEVICE_INFO             1       //device info for USB camera
#define SOFTWARE_INFO           2       //software version for USB camera
#define DRIVER_INFO      3              //driver version for USB camera

//WORKMODE Parameter for okCamSetConfigParam and okCamGetConfigParam
#define FREE 1                          //free mode
#define TRIG 2                          //trig mode
#define EXTSYN 3                        //external synchronization
#define FREEZEFRAME 4                   //last frame freeze
#define PULSETRIG  5                    //pulse trig mode

//FRAMEMODE Parameter okCamSetConfigParam and okCamGetConfigParam
#define FULL 1                          //full screen mode
#define PART 2                          //part screen mode
#define BINNING 3                       //binning mode
#define INTERLACE 4                     //interlace mode

//NET INFO
#define ARM_INFO                1       //arm program version
#define CORE_INFO               2       //core version
#define FPGA_INFO               3       //fpga version

#define CCD_IDENT_CODE  0xFFFE

#ifdef __cplusplus
extern "C" {            /* Assume C declarations for C++ */
#endif /* __cplusplus */

//DLL̬ӿں
/*
ܣʼȱʡԶ豸õƷͺţþ
*lTypeCode    ƷͺŵĴָ(in/out)
      *szPortName    ˿ƵĴָ(in/out)
ֵóɹһȫ־HANDLE hCameraδܴ0false;
*/
/*
This function opens the camera, initializes the default parameters, detects the camera 
linked automatically to get the product ID and return the handle of the camera.
Parameters:
   *lTypeCode      pointer of product ID(in/out)
   *szPortName     pointer of Port connected(in/out)
Return Value:
   A handle to the camera indicates success. 0 indicates failure
*/   
HANDLE WINAPI okCamOpenCamera(long *lTypeCode,char *szPortName);

/*
ܣرͷþ
: hCamera þ in
ֵ0ʾʧܣ1ʾóɹ;
˵ʹĳһʱһҪô˺ر
*/
/*
This function closes the camera, release the handle of the camera.
Parameters:
    hCamera        Handle of camera(in)
Return Value:
    1 indicates success, 0 indicates failure.
Remarks:
    If a camera is not used, this function must be called to close the camera.
*/
BOOL  WINAPI okCamCloseCamera(HANDLE hCamera);

/*
ܣ趨
: hCamera þ in
      wParam:Ŀin
      lParam:ӦwParamֵ.in/out
      Des: 0ʾֻ趨ĵǰ1ʾֻ洢壬2ʾ趨ǰ洢
ֵ0ʾʧܣ1ʾóɹ;
*/
/*
This function is used to set parameters of the camera.
Parameters:
      hCamera       Handle of camera(in)
	  wParam        the item to be set(in)
	  lParam        value of the item (in/out)
	  Des           0 indicates only set current parameters;1 indicates only save to memory;
	                2 indicates set current parameters and save to memory.
Return Value:
      1 indicates success, 0 indicates failure.	                
*/
long  WINAPI okCamSetConfigParam(HANDLE hCamera,long wParam,long lParam,short Des);
/*
ܣȡ
: hCamera þ in
      wParam:Ŀin
      lParam:ӦwParamĲָ out
	  Des: 0ʾֻȡĵǰ1ʾֻȡڵĲ
ֵ0ʾʧܣ1ʾóɹ;
*/
/*
This function is used to get parameters of the camera.
Parameters:
      hCamera       Handle of camera(in) 
      wParam        the item to be get(in)
	  lParam        value of the item (out)
	  Des           0 indicates only get current parameters;1 indicates only get memory parameters;
Return Value:
      1 indicates success, 0 indicates failure.	
*/
long  WINAPI okCamGetConfigParam(HANDLE hCamera,long wParam,void *lParam,short Des);

/*
ܣڵĲĵǰ
: hCamera þ in
ֵ0ʾʧܣ1ʾóɹ;
*/
/*
This function is used to set current parameters with the value saved in memory.
Parameters:
      hCamera       Handle of camera(in) 
Return Value:
      1 indicates success, 0 indicates failure.   
*/
long  WINAPI okCamRecallParam(HANDLE hCamera);
/*
ܣǰ洢
: hCamera þ in
ֵ0ʾʧܣ1ʾóɹ;
*/
/*
This function is used to save current parameters to memory.
Parameters:
      hCamera       Handle of camera(in) 
Return Value:
      1 indicates success, 0 indicates failure.   
*/
long  WINAPI okCamMemorizeParam(HANDLE hCamera);

/*
: hCamera þ in
      lpConfigFile ļָ in 
ֵ0ʾʧܣ1ʾóɹ;
˵ڽǰĲ洢ָļС
*/
/*
This function is used to save current parameters to ConfigFile.
Parameters:
      hCamera       Handle of camera(in) 
	  lpConfigFile  Pointer to the name of ConfigFile(in)
Return Value:
      1 indicates success, 0 indicates failure.
 */
BOOL  WINAPI okCamSaveConfigFile(HANDLE hCamera,LPSTR lpConfigFile);

/*
ܣȡļǰ

: hCamera þ in 
      lpConfigFile ļָ in
ֵ0ʾʧܣ1ʾóɹ;
˵ô洢ָļеĲ趨ĵǰ
*/
/*
This function is used to load ConfigFile to set current parameters.
Parameters:
      hCamera       Handle of camera(in) 
	  lpConfigFile  Pointer to the name of ConfigFile(in)
Return Value:
      1 indicates success, 0 indicates failure.   
*/
BOOL  WINAPI okCamLoadConfigFile(HANDLE hCamera,LPSTR lpConfigFile);

/*
ܣõ 
: 
ֵ;
*/
/*
This function is used to get the latest error occured.
Return Value:
      Error code will be returned.
*/
long   WINAPI okCamGetLastError();

/*
ܣ״̬ 
: hCamera þ in
ֵ0ʾ豸ӣ1ʾ;
*/
/*
This function is used to detect link status of camera.
Parameters:
      hCamera       Handle of camera(in) 
Return Value:
      0 indicates no camera connected, 1 indicates well connected.
*/
BOOL  WINAPI okCamGetLinkStatus(HANDLE hCamera);

/*
ܣع趨Χ

: hCamera þ in
      expose_min   عСֵָ out
      expose_max   عֵָ out
ֵ0ʾʧܣ1ʾóɹ;
˵عķΧ湤ģʽԼʵı仯仯
      Եģʽлʵ仯ʱҪ¼عΧ
*/
/*
This function is used to calculate the range of expose line.
Parameters:
     hCamera       Handle of camera(in) 
	 expose_min    pointer to variable of min expose line value(out)
	 expose_max    pointer to variable of max expose line value(out)
Return Value:
     1 indicates success, 0 indicates failure.
Remarks:
     The range of expose line changes when the work mode and actual total line change, 
	 so when work mode change occurs or actual total line changes, expose line range needs
	 to be recalculated.
 */
BOOL WINAPI   okCamCalExposeRange(HANDLE hCamera,long *expose_min,long *expose_max);

/*
ܣ㳡Ƶ
: hCamera þ in
      Index   Ƶֵ in
ֵõĳƵ;
˵ڳƵʵ仯仯ֵ볡ƵĶӦϵᷢ仯
      ģʽ仯ھֲģʽ¾ֲʼлֲз仯ʱҪ¼㳡Ƶ
*/
/*
This function is used to calculate frame rate.
Parameters:
      hCamera       Handle of camera(in) 
	  Index         frame rate index(in)
Return Value:
      frame rate as the result of calculation 
Remarks:
      The frame rate changes when total line changes, so the relationship between index and 
	  frame rate will change at the same time.Frame rate needs to be recalculated when frame mode
	  changes,start line and end line changes in Part Mode.
 */
double WINAPI  okCamCalFrameRate(HANDLE hCamera,long Index);
/*
ܣععʱ

: hCamera þ in
      expose_line   ع in
ֵ-1ʾʧܣ-2ʾĳģʽЧóɹعʱ;
˵ڵعʱʱĲΪعΪûԵõǰعʱ䣬Ҫת
*/
/*
This function is used to calculate expose time with given expose line.
Parameters:
     hCamera       Handle of camera(in) 
	 expose_line   value of expose line(in)
Return value:
     Return expose time if succeeds, -1 indicates failure, -2 indicates invalid index
Remarks:
     When change expose time, the actual parameter of input and output are expose line.
	 So we have to do transformation to get current expose time.
 */
long  WINAPI  okCamCalExposeTime(HANDLE hCamera,long expose_line);

/*
ܣعʱع
: hCamera þ in
      expose_time عʱ   in
ֵ-1ʾʧܣóɹع;
˵ڵعʱʱĲΪعûҪعʱʱҪת
*/
/*
This function is used to calculate expose line with given expose time.
Parameters:
      hCamera       Handle of camera(in) 
	  expose_time   value of expose time(in)  
Return Value:
      Return expose line if succeeds, -1 indicates failure.
Remarks:
      When change expose time, the actual parameter of input and output are expose line.
	  So we have to do transformation to get current expose time.  
 */
long  WINAPI  okCamCalExposeLine(HANDLE hCamera,long expose_time);
/*
ܣòƷͺŴͺ
: hCamera þ in
      lpCameraName ͺ   in/out
ֵ0ʾʧܣóɹͺŴ롣
˵lpCameraNameͺ򿪲ɹ򷵻ͺδ֪
*/
/*
This function is used to get ProductID and Camera Name.
Parameters:
     hCamera       Handle of camera(in) 
	 lpCameraName  pointer to Camera Name(in/out)
Return Value:
     Return ProductID if succeeds, 0 indicates failure.
Remarks:
     lpCameraName returns Camera Name if succeeds, if open fails return type unknown.     
 */
long  WINAPI okCamGetTypeCode(HANDLE hCamera,LPSTR* lpCameraName);
//òƷ汾
/*
ܣõİ汾
hCamera þ in
      LPSTR lpCameraVer  
ֵЧ˿豸ʱʧܣ0óɹزƷͺŴ롣
 */
/*
This function is used to get VerCode of camera.
Parameters:
     hCamera       Handle of camera(in) 
	 lpCameraVer   reserved
Return Value:
     Return ProductID if succeeds, 0 indicates failure.  
 */
long  WINAPI okCamGetVerCode(HANDLE hCamera,LPSTR lpCameraName);
//òƷ汾
/*
ܣõİ汾
LPSTR lpDriverver  
ֵ İ汾
 */
/*
This function is used to get driver ver.
Parameters:
     hCamera       Handle of camera(in)
	 lpDriverver   reserved
Return Value:
     Return driver ver.
 */
long  WINAPI okCamGetDriverVer(HANDLE hCamera,LPSTR lpCameraName);
/*
 *  ܣGAMMA壬߶ζ˵λ
 *	GAMMAֵͼԶGAMMAֵҲѡ׼GAMMAֵ0.450.61
 *	룺m_handle 豸
 *		  hWnd  븸ھΪNULL޸ڡ
 *		  gammadata ûGAMMAֵָ룬ȷϷʱΪGAMMAֵ
 *        length  GAMMAеĳȣԭΪ1024
 *		  segnum GAMMAģ߶÷Χ4-49
 *		  flag:  TRUEʾGAMMAУFALSEʾĬֵ
 *		  ExSetInit صڴGAMMAǰгʼ.
 *		  ExSetGamma صӦradio button豸ӦGammaֵ.
 *  أóɹ򷵻1ȷϷʱgammadata޸ģرշʱgammadata䡣
 *  ˵GAMMAΪûṩһּ෽ɡ༭GAMMAеķʽ
 *		  û༭GAMMAֵͨصExSetGammaص
 *        ExSetInitڴǰĳʼgammadataҪڵ
 *		  ǰڴռ䲢ʼռĴСΪlength
 */
/* 
This function is used to set Gamma panel. You can config Gamma by draging mouse to use your own 
Gamma data, and you also can choose Gamma value system provided, such as 0.45, 0.6 and 1.
Parameters:
         m_handle:  handle of camera(in)
		 hWnd:      handle of parent window, NULL indicates no parent window(in)
		 gammadata: pointer to user gamma data for input and output(in/out)
		 length:    length of gamma data input.Normally 1024(in)
		 segnum:    segment of gamma curve. valid range is 4-49(in)
		 flag:      TRUE indicates displaying input gamma data, FALSE indicates displaying default(in)
		 ExSetInit: Callback function used to initialize Gamma panel before display
		 ExSetGamma:Callback function, responses to radio button to set relevant Gamma
Return Value:
         1 indicates succeeds.If return with ok, gamma data is changed, If return with cancel, gamma
		 data is not changed.
Remarks:
         User can use this function to generate and edit gamma data.Gamma data user changed can be 
		 exported by callback function ExSetGamma.Callback function ExSetInit is used to initialize
		 gamma panel.User need to allocate memory for gamma data before use, size of memory to be allocated 
		 is length.
*/
long  WINAPI okGammaDlgCallback(HANDLE m_handle,HWND hWnd,long* gammadata, int length,int segnum,BYTE flag, 
								   void CALLBACK ExSetInit(HANDLE m_handle,HWND hWnd),
								   void CALLBACK ExSetGamma(HANDLE m_handle,long* gammadata,int len,int reserved));
/*
ܣصڴGAMMAǰĳʼ
m_handle  
      hWnd      okGammaDlgCallBackõĸھ
 */ 
/*
This callback function is used to initialize gamma panel.
Parameters:
      m_handle:  handle of camera(in)
      hWnd       handle of parent window, result of calling okGammaDlgCallback(in)
 */
void CALLBACK ExSetInit(HANDLE m_handle,HWND hWnd);
/*
ܣصӦGAMMAradio buttonĵӦGAMMAֵ
m_handle  
      gammadata õGAMMAֵָ
	  len       GAMMAֵ
	  reserved  GAMMAУʱ1򷵻0
 */
/*
This callback function is used to  response to radio button on Gamma panel to get relevant gamma data.
Parameters:
      m_handle   handle of camera(in)
	  gammadata  pointer to user gamma data for output(out)
	  len        length of gamma data
	  reserved   1 indicates no gamma correction, otherwise 0
 */
void CALLBACK ExSetGamma(HANDLE m_handle,long* gammadata,int len,int reserved);
/*
ܣݻڵд

: hCamera þ in
      lpBuffer   ݻ in
      WriteLength   дݵĳ in
	  lTimeouts     ʱЧ,0 in
ֵ0ʾʧܣóɹдֽ;
*/
/*
This function is used to write buffer data to serial com
Parameters:
     hCamera      handle of camera(in)
	 lpBuffer     data buffer(in)
	 WriteLength  length of data to be written(in)
	 lTimeouts    reserved, must be 0(in)
Return Value:
     If succeeds return bytes written, if fails return 0.
 */
long WINAPI okCamWriteSerial(HANDLE hCamera, LPBYTE lpBuffer, UINT WriteLength, long lTimeouts);
/*
ܣݶݻ

: hCamera þ in
      lpBuffer   ݻ in
      ReadLength   ݵĳ in
	  lTimeouts   öڳʱ in
ֵ0ʾʧܣóɹضֽ;
*/
/*
This function is used to read data to buffer from serial com
Parameters:
      hCamera     handle of camera(in)
	  lpBuffer    data buffer(in)
	  ReadLength  length of data to be read(in)
	  lTimeouts   timeouts of read com(in)
Return Value:
      If succeeds return bytes read, if fails return 0.
 */
long WINAPI okCamReadSerial(HANDLE hCamera, LPBYTE lpBuffer, UINT ReadLength, long lTimeouts);

/*
ܣɼUSBͼ
hCamera þ in
      m_dib   DIB  out
	  nParam  0--ɼƵͼ񣬷0--ɼ֡ͼ
ֵ0ʾóɹ-1ʾʧ
 */
/*
This function is used for USB Camera to capture image for USB Camera.
Parameters:
      hCamera     handle of camera(in) 
	  m_dib       handle of DIB(out)
	  nParam      0 indicates capture video, otherwise capture frame
Return Value:
      If succeeds return 0, if fails return -1.
 */
LONG WINAPI okCamCaptureFrame(HANDLE hCamera,HDIB* m_dib, int nParam);
//Ŀɼ
/*
ܣĿɼ
hCamera þ in
      rect    Ŀɼ in
ֵ: 0ʾóɹ-1ʾʧ     
/*
This function is use for USB Camera to set target rect for capture.
Parameters:
      hCamera     handle of camera(in)
	  rect        target rect(in)
Return Value:
      If succeeds return 0, if fails return -1
 */
LONG WINAPI okCamSetTargetRect(HANDLE hCamera, RECT rect);
/*
ܣòɼ
hCamera  þ in
      hwnd     ɼ򴰿ھ in
	  frameNum ܲɼ֡ out 
ֵ0ʾóɹ-1ʾʧ 
 */
/*
This function is used to calculate capture rate for USB Camera
Parameters:
      hCamera     handle of camera(in)
	  hwnd        handle for the invalidate rect(in)
	  frameNum    total grab frame number(out)
Return Value:
      If succeeds return 0, if fails return -1
 */
float WINAPI okCamGetCaptureRate(HANDLE hCamera,HWND hwnd, int* frameNum);
/*
ܣֹͣͼɼ
hCamera þ in
ֵ0
 */
/*
This function is used to stop capturing video
Parameters:
     hCamera     handle of camera(in)
Return Value: 0     
 */
//extern "C" LONG WINAPI okCamCapStop(HANDLE hCamera);//okCamStopCapture
LONG WINAPI okCamStopCapture(HANDLE hCamera);
/*
ܣUSBϢ
hCamera  þ in
      wParam:Ŀin
      lParam:ӦwParamĲָ out
ֵ0ʾóɹ-1ʾʧ
 */
/*
This function is used to get info of USB camera.
Parameters:
      hCamera       Handle of camera(in) 
      wParam        the item to be get(in)
	  lParam        value of the item (out)
Return Value:
      0 indicates success, -1 indicates failure.	
*/
long  WINAPI okCamGetUsbInfo(HANDLE hCamera,long wParam,void *lParam);
//жĳһǷ֧
 /*wParam ָܵĺ궨
 ָ֧ܷ1ַ֧0*/
/*This function is used to judge camera support an Item or not
      hCamera      Handle of camera(in)
	  wParam       item to be judged 
Retrun value:
      1 indicates support, 0 indicates not.*/
long  WINAPI okCamFunctionTag(HANDLE hCamera,long wParam);
//溯ԶAM1430
//жع⹦عʱ䷶Χ
/*This function is used to calculate expose range of cameras support short expose.
       hCamera       Handle of camera(in)
	   expose_min    pointer to min exposetime(out)
	   expose_max    pointer to max exposetime(out)
Return value:
       TRUE indicates success,FALSE indicates failure*/
BOOL WINAPI   okCamCalExposeShortRange(HANDLE hCamera,long *expose_min,long *expose_max);
//عʱжع⹦عͶعⲿֲ
/*This function is used to calculate expose line by expose time for cameras support short expose
		hCamera      Handle of camera(in)
		expose       expose time(in)
		expose_line  pointer to expose_line(out)
Return value:
        short expose param, used to config CONFIG_SHORT_EXPOSE if success,-1 indicates failure.*/
long  WINAPI  okCamCalExposeshort_data(HANDLE hCamera,long expose, long *expose_line);
//عжع⹦عⲿعʱ
/*This function is used to calculate short expose for cameras support short expose
		hCamera      Handle of camera(in)
		tirg         short expose param by CONFIG_SHORT_EXPOSE,returned by okCamCalExposeshort_data(in)
Return value:
        value of short expose if success, -1 indicates failure.Expose time of cameras support short expose
		is the combination of short expose and common expose calculated by expose_line.*/
long  WINAPI  okCamCalExposeshort_Time(HANDLE hCamera,long trig);
//ǧ
/*This function is used to scan net camera connected in local network.
		camInfo       pointer to CAMERAINFO structure(out).Attention:if there are n net camera connected, memory allocated at least n*sizeof(CAMERAINFO).
		nIndex        reserved.
Return value:
		numbers of net camera connected.*/
LONG WINAPI okCamScanDevice(CAMERAINFO *camInfo, LONG** nIndex);
 //ǧ
/*This function is used to set net camera Info.
        camInfo       structure of CAMERAINFO;
        size          equals to sizeof(CAMERAIFNO)*n, n is the number of cameras detected.
Return value:0.*/
LONG WINAPI okSetCameraInfo(CAMERAINFO camInfo, long size);
//ȡǧ汾
/*This function is used get ver info of net camera.
        hCamera       Handle of camera(in)
		wParam        the item to be get(in)
	    lParam        pointer to value of the item (out) 
Return value:
        1 indicates success, 0 indicates failure;*/
long WINAPI  okCamGetNetCameraVer(HANDLE hCamera,long wParam, int *lParam);
//ǧIP
/*This function is used to set net camera IP info.
        hCamera       Handle of camera(in)
        NewIp         pointer to camera's new Ip(in)
		Restart        1 indicates restart immediately and 0 indicates restart later(in)
Return value:
        1 indicates success, 0 indicates failure;*/
int WINAPI okCamSetNetCameraIP(HANDLE hCamera,char *NewIp,short Restart);
//ǧIP
/*This function is used to read net camera's IP info.
		hCamera       Handle of camera(in)
		pcIp          pointer to camera's IP read(out)
		pcMac         reserved,can be set NULL.
Return value:
		1 indicates success, 0 indicates failure;*/
int WINAPI okCamGetNetCameraIP(HANDLE hCamera,char *pcIp,char *pcMac);

#ifdef __cplusplus
}
#endif    /* __cplusplus */

//typecode definition
#define AM1100 201100
#define AM1101 201101
#define AM1105 201105
#define AM1120 201120
#define AM1121 201121
#define AM1130 201130
#define AM1131 201131
#define AM1300 201300
#define AM1320 201320
#define AM1330 201330
#define AM1400 201400
#define AM1420 201420
#define AM1421 201421
#define AM1430 201430
#define AM1431 201431
#define AM1500 201500
#define AM1520 201520
#define AM1521 201521
#define AM1530 201530
#define AM1531 201531
#define AC1200 211200
#define AC1300 211300
//USB Camera
#define SC3010 313010
#define SC1310 311310
#define SC2010 312010
#define AM1110 201110
#define AM1310 201310
#define AM1410 201410
#define AC1310 211310
#define AC1210 211210
//ǧ
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
#define AM1160 201160
#define AM1161 201161
#define AM1360 201360
#define AC1360 211360
#define AM1460 201460
#define AM1560 201560


#endif
